#include <stdio.h>
#include <algorithm>
#include <vector>

using namespace std;

vector<int> v;
int N, K, M, i, j, cnt, li, ls, mid, ans;

int OK(int d) {
	cnt = 1;
	
	for (i = 2; i < M - 1 && cnt < N; i++) {
		if (i > 2 * cnt * K)
			break;
		if (v[i + 1] - v[i] <= d) {
			cnt++;
			i++;
		}
	}

	if (cnt == N)
		return 1;
	return 0;
}

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d %d", &N, &K);
	M = 2 * N * K;
	v.resize(M);
	for (i = 0; i < M; i++)
		scanf("%d", &(v[i]));

	sort(v.begin(), v.end());
	
	li = v[1] - v[0]; ls = ans = v[M - 1] - v[0];
	
	while (li <= ls) {
		mid = (li + ls) >> 1;
		if (OK(mid)) {
			ans = mid;
			ls = mid - 1;
		} else
			li = mid + 1;
	}
	
	printf("%d\n", ans);
	return 0;
}
