#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <string>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define MOD 1000000007

#define KMAX 10

long long answer, ans, comb[KMAX][KMAX], fact[KMAX], cnt[KMAX][KMAX][KMAX], power[KMAX][KMAX];
int N, K, p, q, r, u, v;

int main() {
	comb[0][0] = 1;
	for (p = 1; p < KMAX; p++) {
		comb[p][0] = 1;
		for (q = 1; q <= p; q++)
			comb[p][q] = (comb[p - 1][q - 1] + comb[p - 1][q]) % MOD;
	}
	
	fact[0] = 1;
	for (p = 1; p < KMAX; p++)
		fact[p] = (fact[p - 1] * p) % MOD;

	for (p = 1; p < KMAX; p++) {
		power[p][0] = 1;
		for (q = 1; q < KMAX; q++)
			power[p][q] = (power[p][q - 1] * p) % MOD;
	}
	
	//freopen("x.txt", "r", stdin);
	scanf("%d %d", &N, &K);

	if (K == 1)
		answer = 1;
	else {
		answer = 0;

		memset(cnt, 0, sizeof(cnt));
		cnt[1][1][1] = 1;
		for (p = 2; p <= K; p++)
			for (q = 2; q <= p; q++)
				for (r = 1; r < p; r++) {
					for (u = 1; u <= p - r; u++) {
						ans = (comb[p - 1][r] * cnt[p - r][q - 1][u]) % MOD;
						ans = (ans * power[u][r]) % MOD;
						cnt[p][q][r] = (cnt[p][q][r] + ans) % MOD;
					}
					//fprintf(stderr, "p=%d q=%d r=%d: %I64d\n", p, q, r, cnt[p][q][r]);
				}
		
		for (q = 1; q <= K; q++)
			for (r = 1; r <= K; r++)
				answer = (answer + cnt[K][q][r]) % MOD;
	}

	for (p = K + 1; p <= N; p++)
		answer = (answer * (N - K)) % MOD;
	answer = (answer * K) % MOD;
	printf("%I64d\n", answer);
	return 0;
}
