#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>

using namespace std;

vector<pair<int, int> > s;

#define NMAX 100100
int a[NMAX], b[NMAX];
int N, K, P, i, x;

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d", &N);
	s.resize(N);
	for (i = 0; i < N; i++) {
		scanf("%d", &x);
		s[i].first = x;
		s[i].second = i;
	}

	if (N == 1) {
		printf("YES\n0\n%d\n", s[0].first);
		return 0;
	}
	
	K = N / 3;
	if (N % 3 > 0)
		K++;
	
	sort(s.begin(), s.end());
	for (i = 0; i < K; i++) {
		a[s[i].second] = s[i].first;
		b[s[i].second] = 0;
	}

	for (i = K ; i < 2 * K; i++) {
		a[s[i].second] = 0;
		b[s[i].second] = s[i].first;
	}

	P = N - 2 * K - 1;
	
	for (i = 2 * K; i < N; i++) {
		a[s[i].second] = s[i].first - P;
		b[s[i].second] = P;
		P--;
	}
	
	printf("YES\n");
	for (i = 0; i < N; i++) {
		printf("%d", a[i]);
		if (i < N - 1)
			printf(" ");
	}
	printf("\n");
	for (i = 0; i < N; i++) {
		printf("%d", b[i]);
		if (i < N - 1)
			printf(" ");
	}
	printf("\n");	
	return 0;
}
