import sys

verbs3 = [
"abode",
"abided",
"abidden",
"abought",
"alit",
"alighted",
"arisen",
"awoken",
"backbitten",
"backfit",
"backlit",
"backslid",
"backslidden",
"been",
"born",
"borne",
"beaten",
"become",
"bedight",
"bedighted",
"befallen",
"begotten",
"begun",
"begirt",
"behight",
"behoten",
"beheld",
"belaid",
"belayed",
"bent",
"bereft",
"bereaved",
"besought",
"beseeched",
"beset",
"bespoken",
"bestrewed",
"bestrewn",
"bestridden",
"bet",
"betaken",
"bethought",
"bewept",
"bid",
"bidden",
"bided",
"bound",
"bitten",
"blawn",
"bled",
"blended",
"blent",
"blessed",
"blest",
"blown",
"bottle-fed",
"bowstrung",
"broken",
"breast-fed",
"bred",
"brought",
"broadcast",
"broadcasted",
"browbeat",
"browbeaten",
"built",
"burnt",
"burned",
"burst",
"bust",
"bought",
"cast",
"caught",
"cheerled",
"chid",
"chidden",
"chosen",
"clapped",
"clapt",
"clear-cut",
"cleft",
"cleaved",
"cloven",
"cleeked",
"cleped",
"ycleped",
"yclept",
"clung",
"clad",
"clothed",
"colorbred",
"colorcast",
"come",
"cost",
"cost-cut",
"counterdrawn",
"counterlit",
"cowritten",
"crash-dived",
"crept",
"creep-fed",
"crib-bitten",
"cross-bitten",
"cross-strung",
"crossbred",
"crosscut",
"crosslit",
"crowed",
"cut",
"dared",
"daydreamt",
"daydreamed",
"dealt",
"deep-frozen",
"dug",
"dight",
"dighted",
"dispread",
"disproven",
"disproved",
"dived",
"done",
"dogfought",
"dought",
"dowed",
"drawn",
"dreamt",
"dreamed",
"drunk",
"drip-fed",
"driven",
"dwelt",
"eaten",
"end-run",
"engirt",
"engraved",
"engraven",
"enwound",
"fallen",
"farebeaten",
"fast-cut",
"fed",
"felt",
"fought",
"found",
"fit",
"fitted",
"flash-frozen",
"fled",
"flung",
"floodlit",
"flown",
"flyblown",
"forborne",
"forborn",
"forbidden",
"force-fed",
"fordone",
"forecast",
"forecasted",
"forefelt",
"foregone",
"foreknown",
"forerun",
"foreseen",
"forshowed",
"foreshown",
"forespoken",
"foretold",
"forgotten",
"forgiven",
"forlorn",
"forsaken",
"forsworn",
"fraught",
"fraughted",
"free-fallen",
"frozen",
"frostbitten",
"gainsaid",
"gaslit",
"gaslighted",
"gelded",
"gelt",
"got",
"gotten",
"ghostwritten",
"gilt",
"gilded",
"gan",
"girded",
"girt",
"given",
"gnawed",
"gnawn",
"gone",
"been",
"graven",
"graved",
"ground",
"grown",
"hagridden",
"halterbroken",
"hamstrung",
"hamstringed",
"hand-fed",
"hand-ridden",
"handsewn",
"handsewed",
"handwritten",
"hung",
"hanged",
"had",
"heard",
"heaved",
"hove",
"hewn",
"hidden",
"hoten",
"hit",
"hoised",
"hoist",
"hoist",
"hoisted",
"held",
"house-sat",
"housebroken",
"hurt",
"inbred",
"indwelt",
"inheld",
"inlaid",
"input",
"inputted",
"inset",
"interblended",
"interblent",
"interbred",
"intercut",
"intergraved",
"intergraven",
"interlaid",
"interset",
"interwoven",
"interwound",
"inwoven",
"inweaved",
"inwound",
"jerry-built",
"kept",
"kent",
"kenned",
"knelt",
"kneeled",
"knit",
"knitted",
"known",
"laden",
"laded",
"landslid",
"landslided",
"laid",
"led",
"leant",
"leaned",
"leapt",
"leaped",
"learnt",
"learned",
"left",
"lent",
"lept",
"let",
"lain",
"lit",
"linebred",
"lip-read",
"lost",
"made",
"meant",
"met",
"molten",
"melted",
"misbecome",
"miscast",
"mischosen",
"miscut",
"misdealt",
"misdone",
"misfallen",
"misfed",
"misgiven",
"misheard",
"mishit",
"misknown",
"mislaid",
"misled",
"mislearnt",
"mislearned",
"misread",
"missaid",
"missent",
"misset",
"misspoken",
"misspelt",
"misspelled",
"misspent",
"missworn",
"mistaken",
"mistaught",
"mistold",
"misthought",
"misunderstood",
"misworn",
"miswed",
"miswedded",
"miswritten",
"moonlit",
"mown",
"naysaid",
"nose-dived",
"nose-dove",
"offset",
"outbid",
"outbred",
"outdone",
"outdrawn",
"outdrunk",
"outdriven",
"outfought",
"outflown",
"outgrown",
"outlaid",
"outleapt",
"outleaped",
"output",
"outputted",
"outridden",
"outrun",
"outseen",
"outsold",
"outshone",
"outshot",
"outsung",
"outsat",
"outslept",
"outsmelt",
"outsmelled",
"outspoken",
"outsped",
"outspent",
"outspun",
"outsprung",
"outstood",
"outsworn",
"outswum",
"outtold",
"outthought",
"outthrown",
"outworn",
"outwound",
"outworked",
"outwrought",
"outwritten",
"overborne",
"overbid",
"overblown",
"overbred",
"overbuilt",
"overbought",
"overcast",
"overcome",
"overcut",
"overdone",
"overdrawn",
"overdrunk",
"overdriven",
"overeaten",
"overfed",
"overflown",
"overgrown",
"overhung",
"overheard",
"overlaid",
"overleapt",
"overleaped",
"overlearnt",
"overlearned",
"overlain",
"overpast",
"overpassed",
"overpaid",
"overridden",
"overrun",
"overseen",
"oversold",
"overset",
"oversewn",
"oversewed",
"overshot",
"overslept",
"oversown",
"oversowed",
"overspoken",
"overspent",
"overspilt",
"overspilled",
"overspun",
"overspread",
"oversprung",
"overstood",
"overstrewed",
"overstrewn",
"overstridden",
"overstruck",
"overstrung",
"overtaken",
"overthought",
"overthrown",
"overworn",
"overwound",
"overwithheld",
"overwritten",
"partaken",
"paid",
"pent",
"penned",
"pinch-hit",
"pled",
"pleaded",
"potshot",
"practice-taught",
"prebound",
"prebuilt",
"precut",
"predone",
"premade",
"prepaid",
"presold",
"preset",
"preshrunk",
"presplit",
"price-cut",
"proofread",
"proven",
"proved",
"put",
"quick-frozen",
"quit",
"rapped",
"rapt",
"re-proven",
"re-proved",
"read",
"reft",
"reaved",
"reawoken",
"reawaken",
"rebid",
"rebound",
"rebroadcast",
"rebuilt",
"recast",
"recut",
"redd",
"redded",
"redealt",
"redone",
"redrawn",
"rove",
"reeved",
"refit",
"reground",
"regrown",
"rehung",
"reheard",
"reknit",
"reknitted",
"relaid",
"relearnt",
"relearned",
"relit",
"relighted",
"remade",
"rent",
"repaid",
"reread",
"rerun",
"resold",
"resent",
"reset",
"resewn",
"resewed",
"reshot",
"resat",
"resown",
"resowed",
"respelled",
"respelt",
"restrung",
"retaken",
"retaught",
"retorn",
"retold",
"rethought",
"retrodden",
"retrofit",
"retrofitted",
"rewoken",
"rewaked",
"reworn",
"rewoven",
"reweaved",
"rewed",
"rewedded",
"rewet",
"rewetted",
"rewon",
"rewound",
"rewritten",
"rid",
"ridded",
"ridden",
"rung",
"risen",
"riven",
"rived",
"rough-hewn",
"roughcast",
"run",
"sand-cast",
"sawn",
"sawed",
"said",
"seen",
"sought",
"self-fed",
"self-sown",
"self-sowed",
"sold",
"sent",
"set",
"sewn",
"sewed",
"shaken",
"shaven",
"shaved",
"shorn",
"sheared",
"shed",
"shent",
"shewn",
"shewed",
"shone",
"shat",
"shit",
"shod",
"shot",
"shortcut",
"shown",
"shrunk",
"shriven",
"shut",
"sidewound",
"sight-read",
"sightseen",
"sung",
"sunk",
"sat",
"skywritten",
"slain",
"slept",
"slid",
"slidden",
"slung",
"slunk",
"slit",
"smelt",
"smelled",
"smitten",
"snapshot",
"sneaked",
"snuck",
"soothsaid",
"sown",
"spoken",
"sped",
"speeded",
"spelt",
"spelled",
"spellbound",
"spent",
"spilt",
"spilled",
"spun",
"spat",
"spit",
"split",
"spoilt",
"spoiled",
"spoonfed",
"spread",
"sprung",
"stall-fed",
"stood",
"stove",
"staved",
"stoved",
"stolen",
"stuck",
"stung",
"stunk",
"straphung",
"strewn",
"strewed",
"stridden",
"struck",
"stricken",
"strung",
"stript",
"stripped",
"striven",
"sublet",
"sunburned",
"sunburnt",
"sworn",
"sweat",
"sweated",
"swept",
"sweeped",
"swollen",
"swum",
"swung",
"swonken",
"switch-hit",
"taken",
"taught",
"team-taught",
"torn",
"telecast",
"telecasted",
"told",
"test-driven",
"test-flown",
"thought",
"thriven",
"thrived",
"thrown",
"thrust",
"thunderstruck",
"thunderstricken",
"tint",
"tined",
"tossed",
"tost",
"trodden",
"troubleshot",
"typecast",
"typeset",
"typewritten",
"unborn",
"unborne",
"unbent",
"unbound",
"unbuilt",
"unclad",
"unclothed",
"underbid",
"underbidden",
"underbought",
"undercut",
"underdolven",
"underdelved",
"underdone",
"underfed",
"undergirt",
"undergirded",
"undergone",
"underlaid",
"underlet",
"underlain",
"underpaid",
"underrun",
"undersold",
"undershot",
"underspent",
"understood",
"undertaken",
"underthrust",
"underwritten",
"undone",
"undrawn",
"undrawn",
"unfrozen",
"unhung",
"unhidden",
"unheld",
"unknit",
"unknitted",
"unladen",
"unladed",
"unlaid",
"unlearnt",
"unlearned",
"unmade",
"unrove",
"unreeved",
"unsaid",
"unsold",
"unsewn",
"unsewed",
"unslung",
"unspoken",
"unspun",
"unstuck",
"unstrung",
"unsworn",
"untaught",
"unthought",
"untrodden",
"unwoven",
"unwound",
"unwritten",
"upbuilt",
"upheld",
"uppercut",
"uprisen",
"upset",
"upsprung",
"upswept",
"uptorn",
"vext",
"vexed",
"woken",
"waylaid",
"worn",
"woven",
"wed",
"wedded",
"wept",
"wended",
"went",
"wet",
"wetted",
"whipsawn",
"whipsawed",
"won",
"wound",
"winterfed",
"wiredrawn",
"wist",
"withdrawn",
"withheld",
"withstood",
"wont",
"wonted",
"worked",
"wrought",
"wrapped",
"wrapt",
"wreaked",
"wroken",
"wrung",
"written",
"zinced",
"zincked"
]

prepositions_unsplit = [
"abaft",
"aboard",
"about",
"above",
"absent",
"across",
"afore",
"after",
"against",
"along",
"alongside",
"amid",
"amidst",
"among",
"amongst",
"anenst",
"apropos",
"apud",
"around",
"as",
"aside",
"astride",
"at",
"athwart",
"atop",
"barring",
"before",
"behind",
"below",
"beneath",
"beside",
"besides",
"between",
"betwixt",
"beyond",
"but",
"by",
"circa",
"concerning",
"despite",
"down",
"during",
"except",
"excluding",
"failing",
"following",
"for",
"forenenst",
"from",
"given",
"in",
"including",
"inside",
"into",
"lest",
"like",
"mid",
"midst",
"minus",
"modulo",
"near",
"next",
"notwithstanding",
"of",
"off",
"on",
"onto",
"opposite",
"out",
"outside",
"over",
"pace",
"past",
"per",
"plus",
"pro",
"qua",
"regarding",
"round",
"sans",
"save",
"since",
"than",
"through",
"throughout",
"till",
"times",
"to",
"toward",
"towards",
"under",
"underneath",
"unlike",
"until",
"unto",
"up",
"upon",
"versus",
"via",
"vice",
"vis-a-vis",
"with",
"within",
"without",
"worth",
"according to",
"ahead of",
"apart from",
"as for",
"as of",
"as per",
"as regards",
"aside from",
"back to",
"because of",
"close to",
"due to",
"except for",
"far from",
"in to",
"inside of",
"instead of",
"left of",
"near to",
"next to",
"on to",
"out from",
"out of",
"outside of",
"owing to",
"prior to",
"pursuant to",
"rather than",
"regardless of",
"right of",
"subsequent to",
"such as",
"thanks to",
"that of",
"up to",
"where as",
"as far as",
"as long as",
"as opposed to",
"as well as",
"at the behest of",
"by means of",
"by virtue of",
"for the sake of",
"in accordance with",
"in addition to",
"in case of",
"in front of",
"in lieu of",
"in order to",
"in place of",
"in point of",
"in spite of",
"on account of",
"on behalf of",
"on top of",
"with regard to",
"with respect to",
"with a view to"
]

prepositions_split = []

def split_prepositions():
    global prepositions_unslit, prepositions_split
    for prep in prepositions_unsplit:
        prepositions_split.append(prep.split())

def match_preposition(l, poz, L):
    global prepositions_split
    for prep in prepositions_split:
        if (poz + len(prep) - 1 >= L):
            continue
        ok = True
        for i in range(len(prep)):
            if (l[poz + i] != prep[i]):
                ok = False
                break
        if ok:
            return True
    return False

def match_preposition2(l, poz):
    global prepositions_split
    for prep in prepositions_split:
        if (poz - len(prep) + 1 < 0):
            continue
        ok = True
        for i in range(len(prep)):
            if (l[poz - len(prep) + 1 + i] != prep[i]):
                ok = False
                break
        if ok:
            return True
    return False

#LOCAL = True
LOCAL = False

def classify():
    global verbs

    if LOCAL:
        f = open("x.txt", "r")
    else:
        f = sys.stdin

    n = int(f.readline())
    for k in range(n):
        s = f.readline()
        r = s.lower()

        L = len(r)
        for i in range(L):
            if ((r[i] < 'a' or r[i] > 'z') and r[i] != '?'):
                r = r[:i] + ' ' + r[i + 1:]

        l = r.split()

        L = len(l)
        updated = True
        while (updated):
            updated = False
            for i in range(L):
                if ((i < L - 1) and (l[i] == "???") and (l[i + 1] != "???")):
                    is_action = False
                    if (l[i + 1] == "been"):
                        is_action = True
                    LL = len(l[i + 1])
                    if (LL > 3 and l[i + 1][LL - 3:] == "ing"):
                        is_action = True
                    if (LL > 2 and (l[i + 1][LL - 2:] == "ed" or l[i + 1][LL - 2:] == "ly")):
                        is_action = True
                    if (l[i + 1] in verbs3):
                        is_action = True
                    if (l[i + 1] == "so" or l[i + 1] == "about"  or l[i + 1] == "not" or l[i + 1] == "a" or l[i + 1] == "an" or l[i + 1] == "the" or l[i + 1] == "too"):
                        is_action= True
                    if match_preposition(l, i + 1, L):
                        is_action = True

                    if (i + 2 < L):
                        LL = len(l[i + 2])
                        if (LL > 3 and l[i + 2][LL - 3:] == "ing"):
                            is_action = True
                        if (l[i + 2] == "to" or l[i + 2] == "about" or l[i + 2] == "in" or l[i + 2] == "over"):
                            is_action = True
                        #if match_preposition(l, i + 2, L):
                        #    is_action = True
                        if (l[i + 2] in verbs3):
                            is_action = True

                    if (i - 1 >= 0):
                        if match_preposition2(l, i - 1):
                            is_action = False
                        #if (l[i - 1] in verbs3):
                        #    is_action = False
                        LL = len(l[i - 1])
                        if (LL > 2 and (l[i - 1][LL - 2:] == "ed" or l[i - 1][LL - 3:] == "ing")):
                            is_action = False

                    if is_action:
                        l[i] = "???it's"
                    else:
                        l[i] = "???its"

                    updated = True

        lq = []
        for i in range(L):
            if (l[i][:3] == "???"):
                lq.append(l[i][3:])

        L = len(s)
        i = 0
        j = 0
        while (i < L):
            if ((i + 2 < L) and (s[i] == '?') and (s[i + 1] == '?') and (s[i + 2] == '?')):
                sys.stdout.write(lq[j])
                j += 1
                i += 3
            else:
                sys.stdout.write(s[i])
                i += 1

split_prepositions()
classify()
