#include <iostream>
#include <sstream>
#include <fstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <bitset>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define snuke(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

typedef long long ll;
#define MOD 1000000007ll

char buf[100010];
string s;

ll two[100010],ten[100010],eleven[100010],dp[100010];

ll all_sum(int D, ll prefix){
    if(D <= 0) return 0;
    
    ll zero_coef = dp[D];
    if(prefix == 0) return zero_coef;
    
    ll two_coef = (two[D] - 1 + MOD) % MOD;
    
    ll one_coef = (two[D] - 1 + MOD) % MOD * 11 % MOD * eleven[D] % MOD;
    
    ll ans = (zero_coef + one_coef * prefix % MOD + two_coef * prefix % MOD * prefix % MOD) % MOD;
    
    return ans;
}

void precalc(void){
    int i;
    
    int M = 100010;
    
    two[0] = 1;
    for(i=1;i<M;i++) two[i] = two[i-1] * 2 % MOD;
    ten[0] = 1;
    for(i=1;i<M;i++) ten[i] = ten[i-1] * 10 % MOD;
    eleven[0] = 0;
    for(i=1;i<M;i++) eleven[i] = (eleven[i-1] * 10 + 1) % MOD;
    
    dp[0] = 0;
    for(i=1;i<M;i++){
        ll a = all_sum(i-1, 4 * ten[i-1] % MOD);
        ll b = all_sum(i-1, 7 * ten[i-1] % MOD);
        ll x = (4 * ten[i-1] + 7 * eleven[i-1]) % MOD;
        ll y = (7 * ten[i-1] + 4 * eleven[i-1]) % MOD;
        ll c = x * y % MOD;
    //  if(i == 2) cout << a << ' ' << b << ' ' << c << endl;
        dp[i] = (a + b + c) % MOD;
    }
}

ll func(void){
    int N=s.length(),i;
    
    ll ans = 0;
    for(i=1;i<=N-1;i++){
        ll tmp = all_sum(i, 0);
        ans = (ans + tmp) % MOD;
        tmp = eleven[i] * eleven[i+1] % MOD * 28 % MOD;
        ans = (ans + tmp) % MOD;
    }
    
    ll pre = 0;
    REP(i,N){
        ll t = ten[N-1-i];
        if(s[i] == '4'){
            pre = (pre + 4 * t) % MOD;
        } else {
            ll tmp = all_sum(N-1-i, (pre + 4 * t) % MOD);
            ans = (ans + tmp) % MOD;
            ll x = (pre + 4 * ten[N-1-i] + 7 * eleven[N-1-i]) % MOD;
            ll y = (pre + 7 * ten[N-1-i] + 4 * eleven[N-1-i]) % MOD;
            tmp = x * y % MOD;
            ans = (ans + tmp) % MOD;
            pre = (pre + 7 * t) % MOD;
        }
    }
    
    return ans;
}

int main(void){
    int i;
    
    precalc();
    
//  cout << dp[1] << ' ' << dp[2] << endl;
    
    scanf("%s", buf);
    s = buf;
    ll ans1 = func();
    
    scanf("%s", buf);
    s = buf;
    ll ans2 = func();
    
    cout << (ans2 - ans1 + MOD) % MOD << endl;
    
    return 0;
}