#include <iostream>
#include <sstream>
#include <fstream>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>
#include <bitset>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

#define REP(i,n) for((i)=0;(i)<(int)(n);(i)++)
#define snuke(c,itr) for(__typeof((c).begin()) itr=(c).begin();itr!=(c).end();itr++)

char buf[1010];

int X,Y;
int r[1010][1010],d[1010][1010],a[1010][1010];

int check(void){
    int ans=0,i,j;
    
    REP(i,X) REP(j,Y){
        if(i+1 < X && a[i+1][j] == (a[i][j] ^ d[i][j])) ans++;
        if(j+1 < Y && a[i][j+1] == (a[i][j] ^ r[i][j])) ans++;
    }
    
    return ans;
}

void left_to_right(void){
    int i,j;
    
    REP(j,Y){
        a[0][j] = 0;
        for(i=1;i<X;i++) a[i][j] = (a[i-1][j] ^ d[i-1][j]);
        if(j > 0){
            int good = 0, bad = 0;
            REP(i,X) if(a[i][j] == (a[i][j-1] ^ r[i][j-1])) good++; else bad++;
            if(good < bad) REP(i,X) a[i][j] = (a[i][j] ^ 1);
        }
    }
}

void top_to_down(void){
    int i,j;
    
    REP(i,X){
        a[i][0] = 0;
        for(j=1;j<Y;j++) a[i][j] = (a[i][j-1] ^ r[i][j-1]);
        if(i > 0){
            int good = 0, bad = 0;
            REP(j,Y) if(a[i][j] == (a[i-1][j] ^ d[i-1][j])) good++; else bad++;
            if(good < bad) REP(j,Y) a[i][j] = (a[i][j] ^ 1);
        }
    }
}

void print(void){
    int i,j;
    
    REP(i,X) REP(j,Y){
        printf("%d", a[i][j] + 1);
        if(j == Y-1) printf("\n"); else printf(" ");
    }
}

int main(void){
    int C,i,j;
    
    cin >> X >> Y >> C;
    REP(i,X){
        scanf("%s", buf);
        REP(j,Y-1) r[i][j] = ((buf[j] == 'E') ? 0 : 1);
        if(i == X-1) break;
        scanf("%s", buf);
        REP(j,Y) d[i][j] = ((buf[j] == 'E') ? 0 : 1);
    }

/*  srand((unsigned int)time(NULL));
    REP(i,X){
        REP(j,Y-1) r[i][j] = rand() % 2;
        if(i == X-1) break;
        REP(j,Y) d[i][j] = rand() % 2;
    }
*/
    int hor = X * (Y - 1);
    int ver = Y * (X - 1);
    
    if(C == 1){
        int tmp = check();
        if(tmp * 4 >= (hor + ver) * 3){
            cout << "YES" << endl;
            print();
        } else {
            cout << "NO" << endl;
        }
        return 0;
    }
    
    if(hor < ver) left_to_right(); else top_to_down();
    
    int tmp2 = check();
    if(tmp2 * 4 >= (hor + ver) * 3){
        cout << "YES" << endl;
        print();
    } else {
        cout << "warning!" << endl;
    }
    
    return 0;
}
