#include <stdio.h>
#include <string.h>
#include <vector>

using namespace std;

#define NMAX 333

char visited[NMAX];
int A[NMAX][NMAX], p[NMAX];
long long s[NMAX], t[NMAX], q[NMAX];
int N, M, i, j, k, idx, x, y;
long long V, dmax, d, dt;
vector<pair<pair<int, int>, long long> > mc, mf;

void DFS(int x) {
	int y;

	visited[x] = 1;
	q[x] = s[x];
	
	for (y = 1; y <= N; y++)
		if (A[x][y] && !visited[y]) {
			p[y] = x;
			DFS(y);
			if (q[y] > t[y]) {
				mc.push_back(make_pair(make_pair(y, x), q[y] - t[y]));
				q[x] += (q[y] - t[y]);
			} else if (q[y] < t[y]) {
				mc.push_back(make_pair(make_pair(x, y), t[y] - q[y]));
				q[x] -= (t[y] - q[y]);				
			}
		}
}

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d %I64d %d", &N, &V, &M);
	for (i = 1; i <= N; i++)
		scanf("%I64d", &s[i]);
	for (i = 1; i <= N; i++)
		scanf("%I64d", &t[i]);

	memset(A, 0, sizeof(A));
	while (M--) {
		scanf("%d %d", &i, &j);
		A[i][j] = A[j][i] = 1;
	}

	memset(p, 0, sizeof(p));
	memset(visited, 0, sizeof(visited));
	mf.clear();
	for (i = 1; i <= N; i++)
		if (!visited[i]) {
			mc.clear();
			DFS(i);
			if (q[i] != t[i]) {
				printf("NO\n");
				return 0;
			}

			while (1) {
				idx = -1;
				dmax = 0;
				for (i = 0; i < mc.size(); i++) {
					d = mc[i].second;
					x = mc[i].first.first;
					y = mc[i].first.second;
					if (s[x] < d)
						d = s[x];
					if (V - s[y] < d)
						d = V - s[y];
					if (d > dmax) {
						dmax = d;
						idx = i;
					}
				}
				
				if (dmax == 0)
					break;

				x = mc[idx].first.first;
				y = mc[idx].first.second;
				s[x] -= dmax;
				s[y] += dmax;
				mc[idx].second -= dmax;
				//fprintf(stderr, "move from %d to %d : %I64d\n", x, y, dmax);
				mf.push_back(make_pair(make_pair(x, y), dmax));
			}
		}

	printf("%u\n", mf.size());
	for (i = 0; i < mf.size(); i++)
		printf("%d %d %I64d\n", mf[i].first.first, mf[i].first.second, mf[i].second);
	
	return 0;
}
